<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInstitution_contact ArrayType
 * @subpackage Arrays
 */
class ArrayOfInstitution_contact extends AbstractStructArrayBase
{
    /**
     * The institution_contact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Institution_contact[]
     */
    public $institution_contact;
    /**
     * Constructor method for ArrayOfInstitution_contact
     * @uses ArrayOfInstitution_contact::setInstitution_contact()
     * @param \StructType\Institution_contact[] $institution_contact
     */
    public function __construct(array $institution_contact = array())
    {
        $this
            ->setInstitution_contact($institution_contact);
    }
    /**
     * Get institution_contact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Institution_contact[]|null
     */
    public function getInstitution_contact()
    {
        return isset($this->institution_contact) ? $this->institution_contact : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInstitution_contact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInstitution_contact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInstitution_contactForArrayConstraintsFromSetInstitution_contact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInstitution_contactInstitution_contactItem) {
            // validation for constraint: itemType
            if (!$arrayOfInstitution_contactInstitution_contactItem instanceof \StructType\Institution_contact) {
                $invalidValues[] = is_object($arrayOfInstitution_contactInstitution_contactItem) ? get_class($arrayOfInstitution_contactInstitution_contactItem) : sprintf('%s(%s)', gettype($arrayOfInstitution_contactInstitution_contactItem), var_export($arrayOfInstitution_contactInstitution_contactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The institution_contact property can only contain items of type \StructType\Institution_contact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set institution_contact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Institution_contact[] $institution_contact
     * @return \ArrayType\ArrayOfInstitution_contact
     */
    public function setInstitution_contact(array $institution_contact = array())
    {
        // validation for constraint: array
        if ('' !== ($institution_contactArrayErrorMessage = self::validateInstitution_contactForArrayConstraintsFromSetInstitution_contact($institution_contact))) {
            throw new \InvalidArgumentException($institution_contactArrayErrorMessage, __LINE__);
        }
        if (is_null($institution_contact) || (is_array($institution_contact) && empty($institution_contact))) {
            unset($this->institution_contact);
        } else {
            $this->institution_contact = $institution_contact;
        }
        return $this;
    }
    /**
     * Add item to institution_contact value
     * @throws \InvalidArgumentException
     * @param \StructType\Institution_contact $item
     * @return \ArrayType\ArrayOfInstitution_contact
     */
    public function addToInstitution_contact(\StructType\Institution_contact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Institution_contact) {
            throw new \InvalidArgumentException(sprintf('The institution_contact property can only contain items of type \StructType\Institution_contact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->institution_contact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Institution_contact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Institution_contact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Institution_contact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Institution_contact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Institution_contact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string institution_contact
     */
    public function getAttributeName()
    {
        return 'institution_contact';
    }
}
