<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for action_response StructType
 * @subpackage Structs
 */
class Action_response extends AbstractStructBase
{
    /**
     * The successcode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $successcode;
    /**
     * The errordetails
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Str_errordetails
     */
    public $errordetails;
    /**
     * The response
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $response;
    /**
     * Constructor method for action_response
     * @uses Action_response::setSuccesscode()
     * @uses Action_response::setErrordetails()
     * @uses Action_response::setResponse()
     * @param bool $successcode
     * @param \StructType\Str_errordetails $errordetails
     * @param string $response
     */
    public function __construct($successcode = null, \StructType\Str_errordetails $errordetails = null, $response = null)
    {
        $this
            ->setSuccesscode($successcode)
            ->setErrordetails($errordetails)
            ->setResponse($response);
    }
    /**
     * Get successcode value
     * @return bool
     */
    public function getSuccesscode()
    {
        return $this->successcode;
    }
    /**
     * Set successcode value
     * @param bool $successcode
     * @return \StructType\Action_response
     */
    public function setSuccesscode($successcode = null)
    {
        // validation for constraint: boolean
        if (!is_null($successcode) && !is_bool($successcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successcode, true), gettype($successcode)), __LINE__);
        }
        $this->successcode = $successcode;
        return $this;
    }
    /**
     * Get errordetails value
     * @return \StructType\Str_errordetails|null
     */
    public function getErrordetails()
    {
        return $this->errordetails;
    }
    /**
     * Set errordetails value
     * @param \StructType\Str_errordetails $errordetails
     * @return \StructType\Action_response
     */
    public function setErrordetails(\StructType\Str_errordetails $errordetails = null)
    {
        $this->errordetails = $errordetails;
        return $this;
    }
    /**
     * Get response value
     * @return string|null
     */
    public function getResponse()
    {
        return $this->response;
    }
    /**
     * Set response value
     * @param string $response
     * @return \StructType\Action_response
     */
    public function setResponse($response = null)
    {
        // validation for constraint: string
        if (!is_null($response) && !is_string($response)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($response, true), gettype($response)), __LINE__);
        }
        $this->response = $response;
        return $this;
    }
}
