<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for institution_contact StructType
 * @subpackage Structs
 */
class Institution_contact extends AbstractStructBase
{
    /**
     * The date_last_noted_as_active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $date_last_noted_as_active;
    /**
     * The institution_member_id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $institution_member_id;
    /**
     * The institution_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $institution_name;
    /**
     * The individual
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Individual
     */
    public $individual;
    /**
     * The contact_title
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $contact_title;
    /**
     * The contact_type_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $contact_type_code;
    /**
     * The contact_type_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $contact_type_name;
    /**
     * The facility_member_id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $facility_member_id;
    /**
     * The facility_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $facility_name;
    /**
     * The primary_contact_flag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $primary_contact_flag;
    /**
     * Constructor method for institution_contact
     * @uses Institution_contact::setDate_last_noted_as_active()
     * @uses Institution_contact::setInstitution_member_id()
     * @uses Institution_contact::setInstitution_name()
     * @uses Institution_contact::setIndividual()
     * @uses Institution_contact::setContact_title()
     * @uses Institution_contact::setContact_type_code()
     * @uses Institution_contact::setContact_type_name()
     * @uses Institution_contact::setFacility_member_id()
     * @uses Institution_contact::setFacility_name()
     * @uses Institution_contact::setPrimary_contact_flag()
     * @param string $date_last_noted_as_active
     * @param string $institution_member_id
     * @param string $institution_name
     * @param \StructType\Individual $individual
     * @param string $contact_title
     * @param string $contact_type_code
     * @param string $contact_type_name
     * @param string $facility_member_id
     * @param string $facility_name
     * @param string $primary_contact_flag
     */
    public function __construct($date_last_noted_as_active = null, $institution_member_id = null, $institution_name = null, \StructType\Individual $individual = null, $contact_title = null, $contact_type_code = null, $contact_type_name = null, $facility_member_id = null, $facility_name = null, $primary_contact_flag = null)
    {
        $this
            ->setDate_last_noted_as_active($date_last_noted_as_active)
            ->setInstitution_member_id($institution_member_id)
            ->setInstitution_name($institution_name)
            ->setIndividual($individual)
            ->setContact_title($contact_title)
            ->setContact_type_code($contact_type_code)
            ->setContact_type_name($contact_type_name)
            ->setFacility_member_id($facility_member_id)
            ->setFacility_name($facility_name)
            ->setPrimary_contact_flag($primary_contact_flag);
    }
    /**
     * Get date_last_noted_as_active value
     * @return string
     */
    public function getDate_last_noted_as_active()
    {
        return $this->date_last_noted_as_active;
    }
    /**
     * Set date_last_noted_as_active value
     * @param string $date_last_noted_as_active
     * @return \StructType\Institution_contact
     */
    public function setDate_last_noted_as_active($date_last_noted_as_active = null)
    {
        // validation for constraint: string
        if (!is_null($date_last_noted_as_active) && !is_string($date_last_noted_as_active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_last_noted_as_active, true), gettype($date_last_noted_as_active)), __LINE__);
        }
        $this->date_last_noted_as_active = $date_last_noted_as_active;
        return $this;
    }
    /**
     * Get institution_member_id value
     * @return string|null
     */
    public function getInstitution_member_id()
    {
        return $this->institution_member_id;
    }
    /**
     * Set institution_member_id value
     * @param string $institution_member_id
     * @return \StructType\Institution_contact
     */
    public function setInstitution_member_id($institution_member_id = null)
    {
        // validation for constraint: string
        if (!is_null($institution_member_id) && !is_string($institution_member_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($institution_member_id, true), gettype($institution_member_id)), __LINE__);
        }
        $this->institution_member_id = $institution_member_id;
        return $this;
    }
    /**
     * Get institution_name value
     * @return string|null
     */
    public function getInstitution_name()
    {
        return $this->institution_name;
    }
    /**
     * Set institution_name value
     * @param string $institution_name
     * @return \StructType\Institution_contact
     */
    public function setInstitution_name($institution_name = null)
    {
        // validation for constraint: string
        if (!is_null($institution_name) && !is_string($institution_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($institution_name, true), gettype($institution_name)), __LINE__);
        }
        $this->institution_name = $institution_name;
        return $this;
    }
    /**
     * Get individual value
     * @return \StructType\Individual|null
     */
    public function getIndividual()
    {
        return $this->individual;
    }
    /**
     * Set individual value
     * @param \StructType\Individual $individual
     * @return \StructType\Institution_contact
     */
    public function setIndividual(\StructType\Individual $individual = null)
    {
        $this->individual = $individual;
        return $this;
    }
    /**
     * Get contact_title value
     * @return string|null
     */
    public function getContact_title()
    {
        return $this->contact_title;
    }
    /**
     * Set contact_title value
     * @param string $contact_title
     * @return \StructType\Institution_contact
     */
    public function setContact_title($contact_title = null)
    {
        // validation for constraint: string
        if (!is_null($contact_title) && !is_string($contact_title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contact_title, true), gettype($contact_title)), __LINE__);
        }
        $this->contact_title = $contact_title;
        return $this;
    }
    /**
     * Get contact_type_code value
     * @return string|null
     */
    public function getContact_type_code()
    {
        return $this->contact_type_code;
    }
    /**
     * Set contact_type_code value
     * @param string $contact_type_code
     * @return \StructType\Institution_contact
     */
    public function setContact_type_code($contact_type_code = null)
    {
        // validation for constraint: string
        if (!is_null($contact_type_code) && !is_string($contact_type_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contact_type_code, true), gettype($contact_type_code)), __LINE__);
        }
        $this->contact_type_code = $contact_type_code;
        return $this;
    }
    /**
     * Get contact_type_name value
     * @return string|null
     */
    public function getContact_type_name()
    {
        return $this->contact_type_name;
    }
    /**
     * Set contact_type_name value
     * @param string $contact_type_name
     * @return \StructType\Institution_contact
     */
    public function setContact_type_name($contact_type_name = null)
    {
        // validation for constraint: string
        if (!is_null($contact_type_name) && !is_string($contact_type_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contact_type_name, true), gettype($contact_type_name)), __LINE__);
        }
        $this->contact_type_name = $contact_type_name;
        return $this;
    }
    /**
     * Get facility_member_id value
     * @return string|null
     */
    public function getFacility_member_id()
    {
        return $this->facility_member_id;
    }
    /**
     * Set facility_member_id value
     * @param string $facility_member_id
     * @return \StructType\Institution_contact
     */
    public function setFacility_member_id($facility_member_id = null)
    {
        // validation for constraint: string
        if (!is_null($facility_member_id) && !is_string($facility_member_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($facility_member_id, true), gettype($facility_member_id)), __LINE__);
        }
        $this->facility_member_id = $facility_member_id;
        return $this;
    }
    /**
     * Get facility_name value
     * @return string|null
     */
    public function getFacility_name()
    {
        return $this->facility_name;
    }
    /**
     * Set facility_name value
     * @param string $facility_name
     * @return \StructType\Institution_contact
     */
    public function setFacility_name($facility_name = null)
    {
        // validation for constraint: string
        if (!is_null($facility_name) && !is_string($facility_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($facility_name, true), gettype($facility_name)), __LINE__);
        }
        $this->facility_name = $facility_name;
        return $this;
    }
    /**
     * Get primary_contact_flag value
     * @return string|null
     */
    public function getPrimary_contact_flag()
    {
        return $this->primary_contact_flag;
    }
    /**
     * Set primary_contact_flag value
     * @param string $primary_contact_flag
     * @return \StructType\Institution_contact
     */
    public function setPrimary_contact_flag($primary_contact_flag = null)
    {
        // validation for constraint: string
        if (!is_null($primary_contact_flag) && !is_string($primary_contact_flag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primary_contact_flag, true), gettype($primary_contact_flag)), __LINE__);
        }
        $this->primary_contact_flag = $primary_contact_flag;
        return $this;
    }
}
