<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for str_errordetails StructType
 * @subpackage Structs
 */
class Str_errordetails extends AbstractStructBase
{
    /**
     * The errornumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errornumber;
    /**
     * The errormessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errormessage;
    /**
     * The errordescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errordescription;
    /**
     * Constructor method for str_errordetails
     * @uses Str_errordetails::setErrornumber()
     * @uses Str_errordetails::setErrormessage()
     * @uses Str_errordetails::setErrordescription()
     * @param string $errornumber
     * @param string $errormessage
     * @param string $errordescription
     */
    public function __construct($errornumber = null, $errormessage = null, $errordescription = null)
    {
        $this
            ->setErrornumber($errornumber)
            ->setErrormessage($errormessage)
            ->setErrordescription($errordescription);
    }
    /**
     * Get errornumber value
     * @return string|null
     */
    public function getErrornumber()
    {
        return $this->errornumber;
    }
    /**
     * Set errornumber value
     * @param string $errornumber
     * @return \StructType\Str_errordetails
     */
    public function setErrornumber($errornumber = null)
    {
        // validation for constraint: string
        if (!is_null($errornumber) && !is_string($errornumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errornumber, true), gettype($errornumber)), __LINE__);
        }
        $this->errornumber = $errornumber;
        return $this;
    }
    /**
     * Get errormessage value
     * @return string|null
     */
    public function getErrormessage()
    {
        return $this->errormessage;
    }
    /**
     * Set errormessage value
     * @param string $errormessage
     * @return \StructType\Str_errordetails
     */
    public function setErrormessage($errormessage = null)
    {
        // validation for constraint: string
        if (!is_null($errormessage) && !is_string($errormessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errormessage, true), gettype($errormessage)), __LINE__);
        }
        $this->errormessage = $errormessage;
        return $this;
    }
    /**
     * Get errordescription value
     * @return string|null
     */
    public function getErrordescription()
    {
        return $this->errordescription;
    }
    /**
     * Set errordescription value
     * @param string $errordescription
     * @return \StructType\Str_errordetails
     */
    public function setErrordescription($errordescription = null)
    {
        // validation for constraint: string
        if (!is_null($errordescription) && !is_string($errordescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errordescription, true), gettype($errordescription)), __LINE__);
        }
        $this->errordescription = $errordescription;
        return $this;
    }
}
